# Update: Get View Interface
* First, generate a scene file by
```sh
# Remember to specify dataset path in the script's main function
python data_generation/tools/generate_scene_pcd.py
# It will generate a scene.pickle file in the dataset folder
```

* Then, try get_view function
```sh
# Remember to specity the scene.pickle file path and camera pose in the script's main function
python data_generation/tools/get_view.py
# The get_view() function will return scene_pcl and obj_pcl_dict
```


# Data Generation
This folder contains assets related to generating datasets. Maintained by Zhengxiao Han.

## 1 Prerequisites
* **OmniObject3d-simplified** dataset downloaded. Contact Jiyao to acquire it.
* [Isaac Sim](https://docs.omniverse.nvidia.com/isaacsim/latest/index.html) installed.

## 2 How to Use

### 2.1 Convert Dataset to .usd Format

```sh
 ~/.local/share/ov/pkg/isaac_sim-2023.1.1/python.sh <path-to-this-repo>/data_generation/tools/convert_dataset.py <path-to-the-dataset>

 # For example:
 # ~/.local/share/ov/pkg/isaac_sim-2023.1.1/python.sh /home/hzx/Projects/ActivePerception/data_generation/tools/convert_dataset.py /home/hzx/Downloads/OmniObject3d-simplified/output
```

### 2.2 Run the Script
* Firstly Specify file paths in [data_generation.yaml](https://github.com/Jiyao06/ActivePerception/blob/main/data_generation/config/data_generation/data_generation.yaml) and [replicator.yaml](https://github.com/Jiyao06/ActivePerception/blob/main/data_generation/config/replicator/replicator.yaml)
* Then run this script:
```sh
 ~/.local/share/ov/pkg/isaac_sim-2023.1.1/python.sh <path-to-this-repo>/data_generation/src/generate_objects.py
```